## jhdf 2.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.6)
PROJECT ( HDFJAVA C Java )

#-----------------------------------------------------------------------------
# Instructions for use : Normal Build
#
# For standard build of HDFJAVA libraries,tests and tools. 
# Run cmake using the HDFJAVA source tree to generate a build tree.
# Enable/Disable options according to requirements and
# set CMAKE_INSTALL_PREFIX to the required install path.
# Make install can be used to install all components for system-wide use.
#
#-----------------------------------------------------------------------------
# Instructions for use : Sub-Project Build
#
# To include HDFJAVA as a sub-project within another project. 
# Set HDFJAVA_EXTERNALLY_CONFIGURED to 1 in the parent project and
# supply values for the following variables...
#
# HDFJAVA_EXPORTED_TARGETS :
#   Set this to the name of the targets variable which controls exports
#   If unset (because parent project does not support/use the 
#   INSTALL (EXPORT target...) syntax), then targets are not configured 
#   for export during install.
#
# HDFJAVA_LIB_DEPENDENCIES :
#   If the build of HDFJAVA libs is being customized, then rules for the
#   dependencies of the HDFJAVA libs may be 'incomplete', add additional
#   dependencies to this variable so that external projects pick them up
#
# HDFJAVA_EXTERNAL_LIB_PREFIX :
#   If the parent project needs to install hdf libraries, but avoid 
#   name conflicts with system versions, then a prefix may be added
#   to ensure that the correct versions configured are used.
#
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# Set the core names of all the libraries
#-----------------------------------------------------------------------------
SET (HDFJAVA_JNI_HDF_LIB_CORENAME          "jhdf")
SET (HDFJAVA_JNI_HDF5_LIB_CORENAME         "jhdf5")
SET (HDFJAVA_NCSA_HDF_LIB_CORENAME         "jarhdf")
SET (HDFJAVA_NCSA_HDF5_LIB_CORENAME        "jarhdf5")
SET (HDFJAVA_NCSA_OBJECT_LIB_CORENAME      "jarhdfobj")
SET (HDFJAVA_NCSA_FITS_LIB_CORENAME        "jarfitsobj")
SET (HDFJAVA_NCSA_H4_LIB_CORENAME          "jarh4obj")
SET (HDFJAVA_NCSA_H5_LIB_CORENAME          "jarh5obj")
SET (HDFJAVA_NCSA_NC2_LIB_CORENAME         "jarnc2obj")
SET (HDFJAVA_TEST_HDF5_LIB_CORENAME        "jartest5")
SET (HDFJAVA_TEST_OBJECT_LIB_CORENAME      "jartestobj")
SET (HDFJAVA_TEST_UITEST_CORENAME          "jaruitest")
SET (HDFJAVA_NCSA_VIEW_LIB_CORENAME        "jhdfview")

#-----------------------------------------------------------------------------
# Set the true names of all the libraries if customized by external project
#-----------------------------------------------------------------------------
SET (HDFJAVA_JNI_HDF_LIB_NAME      "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_JNI_HDF_LIB_CORENAME}")
SET (HDFJAVA_JNI_HDF5_LIB_NAME     "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_JNI_HDF5_LIB_CORENAME}")
SET (HDFJAVA_NCSA_HDF_LIB_NAME     "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_NCSA_HDF_LIB_CORENAME}")
SET (HDFJAVA_NCSA_HDF5_LIB_NAME    "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_NCSA_HDF5_LIB_CORENAME}")
SET (HDFJAVA_NCSA_OBJECT_LIB_NAME  "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_NCSA_OBJECT_LIB_CORENAME}")
SET (HDFJAVA_NCSA_FITS_LIB_NAME    "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_NCSA_FITS_LIB_CORENAME}")
SET (HDFJAVA_NCSA_H4_LIB_NAME      "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_NCSA_H4_LIB_CORENAME}")
SET (HDFJAVA_NCSA_H5_LIB_NAME      "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_NCSA_H5_LIB_CORENAME}")
SET (HDFJAVA_NCSA_NC2_LIB_NAME     "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_NCSA_NC2_LIB_CORENAME}")
SET (HDFJAVA_TEST_HDF5_LIB_NAME    "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_TEST_HDF5_LIB_CORENAME}")
SET (HDFJAVA_TEST_OBJECT_LIB_NAME  "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_TEST_OBJECT_LIB_CORENAME}")
SET (HDFJAVA_TEST_UITEST_NAME      "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_TEST_UITEST_CORENAME}")
SET (HDFJAVA_NCSA_VIEW_LIB_NAME    "${HDFJAVA_EXTERNAL_LIB_PREFIX}${HDFJAVA_NCSA_VIEW_LIB_CORENAME}")

#-----------------------------------------------------------------------------
# Set the target names of all the libraries
#-----------------------------------------------------------------------------
SET (HDFJAVA_JNI_HDF_LIB_TARGET       ${HDFJAVA_JNI_HDF_LIB_CORENAME})
SET (HDFJAVA_JNI_HDF5_LIB_TARGET      ${HDFJAVA_JNI_HDF5_LIB_CORENAME})
SET (HDFJAVA_NCSA_HDF_LIB_TARGET      ${HDFJAVA_NCSA_HDF_LIB_CORENAME})
SET (HDFJAVA_NCSA_HDF5_LIB_TARGET     ${HDFJAVA_NCSA_HDF5_LIB_CORENAME})
SET (HDFJAVA_NCSA_OBJECT_LIB_TARGET   ${HDFJAVA_NCSA_OBJECT_LIB_CORENAME})
SET (HDFJAVA_NCSA_FITS_LIB_TARGET     ${HDFJAVA_NCSA_FITS_LIB_CORENAME})
SET (HDFJAVA_NCSA_H4_LIB_TARGET       ${HDFJAVA_NCSA_H4_LIB_CORENAME})
SET (HDFJAVA_NCSA_H5_LIB_TARGET       ${HDFJAVA_NCSA_H5_LIB_CORENAME})
SET (HDFJAVA_NCSA_NC2_LIB_TARGET      ${HDFJAVA_NCSA_NC2_LIB_CORENAME})
SET (HDFJAVA_TEST_HDF5_LIB_TARGET     ${HDFJAVA_TEST_HDF5_LIB_CORENAME})
SET (HDFJAVA_TEST_OBJECT_LIB_TARGET   ${HDFJAVA_TEST_OBJECT_LIB_CORENAME})
SET (HDFJAVA_TEST_UITEST_TARGET       ${HDFJAVA_TEST_UITEST_CORENAME})
SET (HDFJAVA_NCSA_VIEW_LIB_TARGET     ${HDFJAVA_NCSA_VIEW_LIB_CORENAME})

#-----------------------------------------------------------------------------
# Define some CMake variables for use later in the project
#-----------------------------------------------------------------------------
SET (HDFJAVA_RESOURCES_DIR       ${HDFJAVA_SOURCE_DIR}/config/cmake)
SET (HDFJAVA_JNI_SRC_DIR         ${HDFJAVA_SOURCE_DIR}/native)
SET (HDFJAVA_JAVA_SRC_DIR        ${HDFJAVA_SOURCE_DIR}/ncsa/hdf)
SET (HDFJAVA_JAVA_OBJECT_SRC_DIR ${HDFJAVA_SOURCE_DIR}/ncsa/hdf/object)
SET (HDFJAVA_TEST_SRC_DIR        ${HDFJAVA_SOURCE_DIR}/test)
SET (HDFJAVA_EXAMPLES_SOURCE_DIR ${HDFJAVA_SOURCE_DIR}/examples)
SET (HDFJAVA_LIB_DIR             ${HDFJAVA_SOURCE_DIR}/lib)

IF (NOT HJAVA_INSTALL_BIN_DIR)
  SET (HJAVA_INSTALL_BIN_DIR bin)
ENDIF (NOT HJAVA_INSTALL_BIN_DIR)
IF (NOT HJAVA_INSTALL_LIB_DIR)
  SET (HJAVA_INSTALL_LIB_DIR lib)
ENDIF (NOT HJAVA_INSTALL_LIB_DIR)
IF (NOT HJAVA_INSTALL_INCLUDE_DIR)
  SET (HJAVA_INSTALL_INCLUDE_DIR include)
ENDIF (NOT HJAVA_INSTALL_INCLUDE_DIR)
IF (NOT HJAVA_INSTALL_DATA_DIR)
  IF (NOT WIN32)
    SET (HJAVA_INSTALL_DATA_DIR share)
    SET (HJAVA_INSTALL_CMAKE_DIR share/cmake)
  ELSE (NOT WIN32)
    SET (HJAVA_INSTALL_DATA_DIR ".")
    SET (HJAVA_INSTALL_CMAKE_DIR cmake)
  ENDIF (NOT WIN32)
ENDIF (NOT HJAVA_INSTALL_DATA_DIR)

#-----------------------------------------------------------------------------
# parse the full version number from hjava.h and include in HJAVA_VERS_INFO
#-----------------------------------------------------------------------------
FILE (READ ${HDFJAVA_SOURCE_DIR}/VERSION _hjava_version_contents)
STRING (REGEX REPLACE ".*VERSION=hdf-java-([0-9]*.[0-9]*).*$"
    "\\1" HJAVA_FULL_VERSION ${_hjava_version_contents})
STRING (REGEX REPLACE ".*VERSION=hdf-java-([0-9]*).*$"
    "\\1" HJAVA_VERS_MAJOR ${_hjava_version_contents})
STRING (REGEX REPLACE ".*VERSION=hdf-java-[0-9]*.([0-9]*).*$"
    "\\1" HJAVA_VERS_MINOR ${_hjava_version_contents})
#STRING (REGEX REPLACE ".*#define[ \t]+HJAVA_LIBVER_RELEASE[ \t]+([0-9]*).*$"
#    "\\1" HJAVA_VERS_RELEASE ${_hjava_version_contents})
#MESSAGE (STATUS "VERSION: ${HJAVA_FULL_VERSION}")
#MESSAGE (STATUS "VERSION MAJOR: ${HJAVA_VERS_MAJOR}")
#MESSAGE (STATUS "VERSION MINOR: ${HJAVA_VERS_MINOR}")
#SET (HJAVA_VERS_MAJOR 2)
#SET (HJAVA_VERS_MAJOR 7)
SET (HJAVA_VERS_RELEASE 0)

#-----------------------------------------------------------------------------
# Basic HDFJAVA stuff here
#-----------------------------------------------------------------------------
SET (HDFJAVA_PACKAGE "hdf-java")
SET (HDFJAVA_PACKAGE_NAME "HDF-JAVA")
SET (HDFJAVA_PACKAGE_VERSION "${HJAVA_VERS_MAJOR}.${HJAVA_VERS_MINOR}.${HJAVA_VERS_RELEASE}")
SET (HDFJAVA_PACKAGE_VERSION_MAJOR "${HJAVA_VERS_MAJOR}")
SET (HDFJAVA_PACKAGE_VERSION_MINOR "${HJAVA_VERS_MINOR}")
SET (HDFJAVA_PACKAGE_STRING "${HDFJAVA_PACKAGE_NAME}")
SET (HDFJAVA_PACKAGE_TARNAME "hdf-java")
SET (HDFJAVA_PACKAGE_URL "http://www.hdfgroup.org/hdfjava")
SET (HDFJAVA_PACKAGE_BUGREPORT "help@hdfgroup.org")

#-----------------------------------------------------------------------------
# Set Install folder value
#-----------------------------------------------------------------------------
IF (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  IF(CMAKE_HOST_UNIX)
    SET(CMAKE_INSTALL_PREFIX "/usr"
      CACHE PATH "Install path prefix, prepended onto install directories." FORCE)
  ELSE(CMAKE_HOST_UNIX)
    GetDefaultWindowsPrefixBase(CMAKE_GENERIC_PROGRAM_FILES)
    SET(CMAKE_INSTALL_PREFIX
      "${CMAKE_GENERIC_PROGRAM_FILES}/HDF_Group/${HDFJAVA_PACKAGE_NAME}/${HDFJAVA_PACKAGE_VERSION}"
      CACHE PATH "Install path prefix, prepended onto install directories." FORCE)
    SET(CMAKE_GENERIC_PROGRAM_FILES)
  ENDIF(CMAKE_HOST_UNIX)
ENDIF (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

FIND_PACKAGE(Java)
#-----------------------------------------------------------------------------
# Include some macros for reusable code
#-----------------------------------------------------------------------------
SET (CMAKE_MODULE_PATH ${HDFJAVA_RESOURCES_DIR})
INCLUDE (${HDFJAVA_RESOURCES_DIR}/UseJava.cmake)
INCLUDE (${HDFJAVA_RESOURCES_DIR}/HDFMacros.cmake)
INCLUDE (${HDFJAVA_RESOURCES_DIR}/HDF45Macros.cmake)
INCLUDE (${HDFJAVA_RESOURCES_DIR}/HDFJavaMacros.cmake)

#-----------------------------------------------------------------------------
# Setup output Directories
#-----------------------------------------------------------------------------
IF (NOT HDFJAVA_EXTERNALLY_CONFIGURED)
  SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all Executables."
  )
  SET (CMAKE_LIBRARY_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all Libraries"
  )
  SET (CMAKE_ARCHIVE_OUTPUT_DIRECTORY
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all static libraries."
  )
  SET (CMAKE_JAVA_TARGET_OUTPUT_DIR 
      ${PROJECT_BINARY_DIR}/bin CACHE PATH "Single Directory for all java jars."
  )
  
ELSE (NOT HDFJAVA_EXTERNALLY_CONFIGURED)
  # if we are externally configured, but the project uses old cmake scripts
  # this may not be set and utilities like Hdetect will fail
  IF (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
    SET (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${EXECUTABLE_OUTPUT_PATH})
  ENDIF (NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
ENDIF (NOT HDFJAVA_EXTERNALLY_CONFIGURED)

#-----------------------------------------------------------------------------
# Targets built within this project are exported at Install time for use
# by other projects using FindHDFJAVA.
#-----------------------------------------------------------------------------
IF (NOT HDFJAVA_EXPORTED_TARGETS)
  SET (HDFJAVA_EXPORTED_TARGETS "HDFJAVA-targets")
ENDIF (NOT HDFJAVA_EXPORTED_TARGETS)

#-----------------------------------------------------------------------------
# To include a library in the list exported by the project AT BUILD TIME,
# add it to this variable. This is NOT used by Make Install, but for projects
# which include HDFJAVA as a sub-project within their build tree
#-----------------------------------------------------------------------------
SET_GLOBAL_VARIABLE (HDFJAVA_LIBRARIES_TO_EXPORT "")
SET_GLOBAL_VARIABLE (HDFJAVA_JARS_TO_EXPORT "")
SET_GLOBAL_VARIABLE (HDFJAVA_HDFVIEWJAR_TO_EXPORT "")

#-----------------------------------------------------------------------------
# Run all the CMake configuration tests for our build environment
#-----------------------------------------------------------------------------
INCLUDE (${HDFJAVA_RESOURCES_DIR}/ConfigureChecks.cmake)

#-----------------------------------------------------------------------------
# Option to use code coverage
#-----------------------------------------------------------------------------

=== examples/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_EXAMPLES)

ADD_SUBDIRECTORY(${HDFJAVA_EXAMPLES_SOURCE_DIR}/datasets     datasets)
ADD_SUBDIRECTORY(${HDFJAVA_EXAMPLES_SOURCE_DIR}/datatypes   datatypes)
ADD_SUBDIRECTORY(${HDFJAVA_EXAMPLES_SOURCE_DIR}/groups      groups)
ADD_SUBDIRECTORY(${HDFJAVA_EXAMPLES_SOURCE_DIR}/intro       intro)

=== native/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_JNI C)

FIND_PACKAGE(JNI)

INCLUDE_DIRECTORIES( ${JNI_INCLUDE_DIRS} )

#-----------------------------------------------------------------------------
# Option to Build Shared/Static libs, default is static
#-----------------------------------------------------------------------------
OPTION (BUILD_SHARED_LIBS "Build Shared Libraries" OFF)
SET (LIB_TYPE STATIC)
IF (BUILD_SHARED_LIBS)
  SET (LIB_TYPE SHARED)
  ADD_DEFINITIONS (-DHDFJAVA_BUILT_AS_DYNAMIC_LIB)
ELSE (BUILD_SHARED_LIBS)
  ADD_DEFINITIONS (-DHDFJAVA_BUILT_AS_STATIC_LIB)
  IF (NOT WIN32)
    # should this be a user setting : Everyone uses it anyway ?
    ADD_DEFINITIONS (-DPIC)
  ENDIF (NOT WIN32)
ENDIF (BUILD_SHARED_LIBS)

#-----------------------------------------------------------------------------
# When building utility executables that generate other (source) files :
# we make use of the following variables defined in the root CMakeLists.
# Certain systems may add /Debug or /Release to output paths
# and we need to call the executable from inside the CMake configuration
#-----------------------------------------------------------------------------
SET (EXE_EXT "")
IF (WIN32)
  SET (EXE_EXT ".exe")
  IF (NOT CYGWIN)
    ADD_DEFINITIONS (-DBIND_TO_CURRENT_VCLIBS_VERSION=1)
    ADD_DEFINITIONS (-D_CRT_SECURE_NO_WARNINGS)
  ENDIF (NOT CYGWIN)
ENDIF (WIN32)

IF (MSVC)
  SET (CMAKE_MFC_FLAG 0)
ENDIF (MSVC)

#-----------------------------------------------------------------------------
# Add some definitions for Debug Builds
#-----------------------------------------------------------------------------
IF (CMAKE_BUILD_TYPE MATCHES Debug)
  ADD_DEFINITIONS(-DDEBUG)
  #-- NMake Makefiles will overwhelm the console with warnings if -Wall is used.
  IF (NOT WIN32)
    ADD_DEFINITIONS (-Wall)
  ENDIF (NOT WIN32)
ELSE (CMAKE_BUILD_TYPE MATCHES Debug)
  ADD_DEFINITIONS (-UH4_DEBUG_API -DNDEBUG)
ENDIF (CMAKE_BUILD_TYPE MATCHES Debug)

#-----------------------------------------------------------------------------
# Compiler specific flags : Shouldn't there be compiler tests for these
#-----------------------------------------------------------------------------
IF (CMAKE_COMPILER_IS_GNUCC)
  SET (CMAKE_C_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_C_FLAGS} -std=c99 -fomit-frame-pointer -finline-functions -fno-common")
ENDIF (CMAKE_COMPILER_IS_GNUCC)
IF (CMAKE_COMPILER_IS_GNUCXX)
  SET (CMAKE_CXX_FLAGS "${CMAKE_ANSI_CFLAGS} ${CMAKE_CXX_FLAGS} -fomit-frame-pointer -finline-functions -fno-common")
ENDIF (CMAKE_COMPILER_IS_GNUCXX)

#-----------------------------------------------------------------------------
# Option to allow the user to disable compiler warnings
#-----------------------------------------------------------------------------
OPTION (HDF_DISABLE_COMPILER_WARNINGS "Disable compiler warnings" OFF)
IF (HDF_DISABLE_COMPILER_WARNINGS)
  # MSVC uses /w to suppress warnings.  It also complains if another
  # warning level is given, so remove it.
  IF (MSVC)
    SET (HDF_WARNINGS_BLOCKED 1)
    STRING (REGEX REPLACE "(^| )([/-])W[0-9]( |$)" " " CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /w")
    STRING (REGEX REPLACE "(^| )([/-])W[0-9]( |$)" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /w")
  ENDIF (MSVC)
  IF (WIN32 AND NOT CYGWIN)
    ADD_DEFINITIONS (-D_CRT_SECURE_NO_WARNINGS)
  ENDIF (WIN32 AND NOT CYGWIN)
  # Borland uses -w- to suppress warnings.
  IF (BORLAND)
    SET (HDF_WARNINGS_BLOCKED 1)
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w-")
  ENDIF (BORLAND)

  # Most compilers use -w to suppress warnings.
  IF (NOT HDF_WARNINGS_BLOCKED)
    SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w")
    SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -w")
  ENDIF (NOT HDF_WARNINGS_BLOCKED)
ENDIF (HDF_DISABLE_COMPILER_WARNINGS)

SET (EXTERNAL_HEADER_LIST "")
SET (EXTERNAL_LIBRARY_LIST "")
SET (EXTERNAL_LIBRARYDLL_LIST "")

#-----------------------------------------------------------------------------
# This is in here to help some of the GCC based IDES like Eclipse
# and code blocks parse the compiler errors and warnings better.
#-----------------------------------------------------------------------------
IF (CMAKE_COMPILER_IS_GNUCC)
  SET (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fmessage-length=0")
ENDIF (CMAKE_COMPILER_IS_GNUCC)
IF (CMAKE_COMPILER_IS_GNUCXX)
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fmessage-length=0")
ENDIF (CMAKE_COMPILER_IS_GNUCXX)

INCLUDE (ExternalProject)
OPTION (HDF_ALLOW_EXTERNAL_SUPPORT "Allow External Library Building" "NO")
OPTION (HDF4_USE_EXTERNAL "Use External Library Building for HDF4" 0)
OPTION (HDF5_USE_EXTERNAL "Use External Library Building for HDF5" 0)
IF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN" OR HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")
  SET (HDF4_USE_EXTERNAL 1 CACHE BOOL "Use External Library Building for HDF4" FORCE)
  SET (HDF5_USE_EXTERNAL 1 CACHE BOOL "Use External Library Building for HDF5" FORCE)
  IF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN")
    SET (HDF4_URL ${HDF4_SVN_URL})
    SET (HDF5_URL ${HDF5_SVN_URL})
  ELSEIF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")
    IF (NOT TGZ_PATH)
      SET (TGZ_PATH ${HDFJAVA_SOURCE_DIR})
    ENDIF (NOT TGZ_PATH)
    SET (HDF4_URL ${TGZ_PATH}/${HDF4_TGZ_NAME})
    SET (HDF5_URL ${TGZ_PATH}/${HDF5_TGZ_NAME})
  ENDIF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN")
ENDIF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN" OR HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")

SET (HDF4_LINK_LIBS ${LINK_LIBS})
SET (HDF5_LINK_LIBS ${LINK_LIBS})

#-----------------------------------------------------------------------------
# HDF4 support
#-----------------------------------------------------------------------------
IF (NOT BUILD_SHARED_LIBS)
  SET (HDF4_USE_STATIC_LIBRARIES 1)
ENDIF (NOT BUILD_SHARED_LIBS)

IF (NOT HJAVA_HDF4_HEADER)
  IF (NOT HDF4_USE_EXTERNAL)
    FIND_PACKAGE (HDF4 NAMES ${HDF4_PACKAGE_NAME}${HDF_PACKAGE_EXT})
    IF (NOT HDF4_FOUND)
      FIND_PACKAGE (HDF4) # Legacy find
    ENDIF (NOT HDF4_FOUND)
  ENDIF (NOT HDF4_USE_EXTERNAL)
  IF (HDF4_FOUND)
    MESSAGE (STATUS "HDF4 found: INC=${HDF4_INCLUDE_DIR} TOOLS=${HDF4_TOOLS_DIR}")
    IF ((NOT USE_SHARED_LIBS AND HDF4_BUILD_SHARED_LIBS) OR (USE_SHARED_LIBS AND NOT HDF4_BUILD_SHARED_LIBS))
      MESSAGE (STATUS "HDF4 build type does match requested type")
    ENDIF ((NOT USE_SHARED_LIBS AND HDF4_BUILD_SHARED_LIBS) OR (USE_SHARED_LIBS AND NOT HDF4_BUILD_SHARED_LIBS))
    IF (HDF4_BUILD_SHARED_LIBS)
      ADD_DEFINITIONS (-DH4_BUILT_AS_DYNAMIC_LIB)
    ELSE (HDF4_BUILD_SHARED_LIBS)
      ADD_DEFINITIONS (-DH4_BUILT_AS_STATIC_LIB)
    ENDIF (HDF4_BUILD_SHARED_LIBS)
    SET (HJAVA_HAVE_HDF_H 1)
    SET (HJAVA_HAVE_HDF4 1)
    SET (HJAVA_HDF4_HEADER "hdf.h")
    SET (HDF4_INCLUDE_DIR_GEN ${HDF4_INCLUDE_DIR})
    SET (HDF4_INCLUDE_DIRS ${HDF4_INCLUDE_DIR})
  ELSE (HDF4_FOUND)
    IF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN" OR HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")
      # May need to build JPEG with PIC on x64 machines with gcc
      # Need to use CMAKE_ANSI_CFLAGS define so that compiler test works
      IF (NOT CMAKE_ANSI_CFLAGS)
        SET (CMAKE_ANSI_CFLAGS " ")
      ENDIF (NOT CMAKE_ANSI_CFLAGS)
      IF (BUILD_JPEG_WITH_PIC)
        SET (CMAKE_ANSI_CFLAGS "${CMAKE_ANSI_CFLAGS} -fPIC")
      ENDIF (BUILD_JPEG_WITH_PIC)
        
      EXTERNAL_HDF4_LIBRARY (${HDF_ALLOW_EXTERNAL_SUPPORT} ${LIB_TYPE})
      SET (HJAVA_HAVE_HDF_H 1)
      SET (HJAVA_HAVE_HDF4 1)
      SET (HJAVA_HDF4_HEADER "hdf.h")
      MESSAGE (STATUS "HDF4 is built")
      IF (BUILD_SHARED_LIBS)
        ADD_DEFINITIONS (-DH4_BUILT_AS_DYNAMIC_LIB)
      ELSE (BUILD_SHARED_LIBS)
        ADD_DEFINITIONS (-DH4_BUILT_AS_STATIC_LIB)
      ENDIF (BUILD_SHARED_LIBS)
    ELSE (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN" OR HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")
      MESSAGE (FATAL_ERROR " HDF4 is Required for  HDFJAVA")
    ENDIF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN" OR HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")
  ENDIF (HDF4_FOUND)
ELSE (NOT HJAVA_HDF4_HEADER)
  # This project is being called from within another and HDF4 is already configured
  SET (HJAVA_HAVE_HDF_H 1)
  SET (HJAVA_HAVE_HDF4 1)
ENDIF (NOT HJAVA_HDF4_HEADER)
IF (NOT HDF4_LIBRARY)
  SET (HDF4_LIBRARY ${HDF4_LIBRARIES})
ENDIF (NOT HDF4_LIBRARY)
IF (NOT TARGET "hdiff")
  ADD_EXECUTABLE (hdiff IMPORTED)
  IF (USE_SHARED_LIBS AND WIN32)
    SET_PROPERTY (TARGET hdiff PROPERTY IMPORTED_LOCATION "${HDF4_TOOLS_DIR}/hdiffdll")
  ELSE (USE_SHARED_LIBS AND WIN32)
    SET_PROPERTY (TARGET hdiff PROPERTY IMPORTED_LOCATION "${HDF4_TOOLS_DIR}/hdiff")
  ENDIF (USE_SHARED_LIBS AND WIN32)
  SET (HDF4_DIFF_EXECUTABLE $<TARGET_FILE:hdiff>)
ENDIF (NOT TARGET "hdiff")
SET (LINK_LIBS ${LINK_LIBS} ${HDF4_LIBRARIES})
SET (HDF4_LINK_LIBS ${HDF4_LINK_LIBS} ${HDF4_LIBRARIES})
INCLUDE_DIRECTORIES (${HDF4_INCLUDE_DIRS})
SET (HDF4_FOUND 1 PARENT_SCOPE)
SET (HDF4_INCLUDE_DIR_GEN ${HDF4_INCLUDE_DIR_GEN} PARENT_SCOPE)

#-----------------------------------------------------------------------------
# HDF5 support
#-----------------------------------------------------------------------------
IF (NOT BUILD_SHARED_LIBS)
  SET (HDF5_USE_STATIC_LIBRARIES 1)
ENDIF (NOT BUILD_SHARED_LIBS)

IF (NOT HJAVA_HDF5_HEADER)
  IF (NOT HDF5_USE_EXTERNAL)
    FIND_PACKAGE (HDF5 NAMES ${HDF5_PACKAGE_NAME}${HDF_PACKAGE_EXT})
    IF (NOT HDF5_FOUND)
      FIND_PACKAGE (HDF5) # Legacy find
    ENDIF (NOT HDF5_FOUND)
  ENDIF (NOT HDF5_USE_EXTERNAL)
  IF (HDF5_FOUND)
    MESSAGE (STATUS "HDF5 found: INC=${HDF5_INCLUDE_DIR} TOOLS=${HDF5_TOOLS_DIR}")
    IF ((NOT USE_SHARED_LIBS AND HDF5_BUILD_SHARED_LIBS) OR (USE_SHARED_LIBS AND NOT HDF5_BUILD_SHARED_LIBS))
      MESSAGE (STATUS "HDF5 build type does match requested type")
    ENDIF ((NOT USE_SHARED_LIBS AND HDF5_BUILD_SHARED_LIBS) OR (USE_SHARED_LIBS AND NOT HDF5_BUILD_SHARED_LIBS))
    IF (HDF5_BUILD_SHARED_LIBS)
      ADD_DEFINITIONS (-DH5_BUILT_AS_DYNAMIC_LIB)
    ELSE (HDF5_BUILD_SHARED_LIBS)
      ADD_DEFINITIONS (-DH5_BUILT_AS_STATIC_LIB)
    ENDIF (HDF5_BUILD_SHARED_LIBS)
    SET (HJAVA_HAVE_H5PUBCONF_H 1)
    SET (HJAVA_HAVE_HDF5 1)
    SET (HJAVA_HDF5_HEADER "h5pubconf.h")
    SET (HDF5_INCLUDE_DIR_GEN ${HDF5_INCLUDE_DIR})
    SET (HDF5_INCLUDE_DIRS ${HDF5_INCLUDE_DIR})
  ELSE (HDF5_FOUND)
    IF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN" OR HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")
      EXTERNAL_HDF5_LIBRARY (${HDF_ALLOW_EXTERNAL_SUPPORT} ${LIB_TYPE})
      SET (HJAVA_HAVE_H5PUBCONF_H 1)
      SET (HJAVA_HAVE_HDF5 1)
      SET (HJAVA_HDF5_HEADER "h5pubconf.h")
      MESSAGE (STATUS "HDF5 is built")
      IF (BUILD_SHARED_LIBS)
        ADD_DEFINITIONS (-DH5_BUILT_AS_DYNAMIC_LIB)
      ELSE (BUILD_SHARED_LIBS)
        ADD_DEFINITIONS (-DH5_BUILT_AS_STATIC_LIB)
      ENDIF (BUILD_SHARED_LIBS)
    ELSE (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN" OR HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")
      MESSAGE (FATAL_ERROR " HDF5 is Required for  HDFJAVA")
    ENDIF (HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "SVN" OR HDF_ALLOW_EXTERNAL_SUPPORT MATCHES "TGZ")
  ENDIF (HDF5_FOUND)
ELSE (NOT HJAVA_HDF5_HEADER)
  # This project is being called from within another and HDF5 is already configured
  SET (HJAVA_HAVE_H5PUBCONF_H 1)
  SET (HJAVA_HAVE_HDF5 1)
ENDIF (NOT HJAVA_HDF5_HEADER)
IF (NOT HDF5_LIBRARY)
  SET (HDF5_LIBRARY ${HDF5_LIBRARIES})
ENDIF (NOT HDF5_LIBRARY)
IF (NOT TARGET "h5diff")
  ADD_EXECUTABLE (h5diff IMPORTED)
  IF (USE_SHARED_LIBS AND WIN32)
    SET_PROPERTY (TARGET h5diff PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5diffdll")
  ELSE (USE_SHARED_LIBS AND WIN32)
    SET_PROPERTY (TARGET h5diff PROPERTY IMPORTED_LOCATION "${HDF5_TOOLS_DIR}/h5diff")
  ENDIF (USE_SHARED_LIBS AND WIN32)
  SET (HDF5_DIFF_EXECUTABLE $<TARGET_FILE:h5diff>)
ENDIF (NOT TARGET "h5diff")
SET (LINK_LIBS ${LINK_LIBS} ${HDF5_LIBRARIES})
SET (HDF5_LINK_LIBS ${HDF5_LINK_LIBS} ${HDF5_LIBRARIES})
INCLUDE_DIRECTORIES (${HDF5_INCLUDE_DIRS})
SET (HDF5_FOUND 1 PARENT_SCOPE)

=== ncsa/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_NCSA)

ADD_SUBDIRECTORY(${HDFJAVA_NCSA_SOURCE_DIR}/hdf     hdf)

=== examples/datatypes/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_EXAMPLES_DATATYPES Java)

SET(CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES(
    ${JAVA_NCSA_HDF_HDF5_BINARY_DIR}
    ${HDFJAVA_LIB_DIR}
)

SET (HDF_JAVA_EXAMPLES
    H5Ex_T_Array
    H5Ex_T_ArrayAttribute
    H5Ex_T_Bit
    H5Ex_T_BitAttribute
    H5Ex_T_Commit
    H5Ex_T_Compound
    H5Ex_T_CompoundAttribute
    H5Ex_T_Float
    H5Ex_T_FloatAttribute
    H5Ex_T_Integer
    H5Ex_T_IntegerAttribute
    H5Ex_T_ObjectReference
    H5Ex_T_ObjectReferenceAttribute
    H5Ex_T_Opaque
    H5Ex_T_OpaqueAttribute
    H5Ex_T_String
    H5Ex_T_StringAttribute
    H5Ex_T_VLString
)

SET (HDF_JAVA_OBJECT_EXAMPLES
    H5ObjectEx_T_Array
    H5ObjectEx_T_ArrayAttribute
    H5ObjectEx_T_Bit
    H5ObjectEx_T_BitAttribute
    H5ObjectEx_T_Commit
    H5ObjectEx_T_Compound
    H5ObjectEx_T_CompoundAttribute
    H5ObjectEx_T_Float
    H5ObjectEx_T_FloatAttribute
    H5ObjectEx_T_Integer
    H5ObjectEx_T_IntegerAttribute
    H5ObjectEx_T_ObjectReference
    H5ObjectEx_T_ObjectReferenceAttribute
    H5ObjectEx_T_Opaque
    H5ObjectEx_T_OpaqueAttribute
    H5ObjectEx_T_String
    H5ObjectEx_T_StringAttribute
    H5ObjectEx_T_VLString
)

IF (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ";")
ELSE (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ":")
ENDIF(WIN32 AND NOT CYGWIN)

SET (CMAKE_JAVA_INCLUDE_PATH ${HDFJAVA_HDF5_JARS})

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (CMAKE_INCLUDE_PATH ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_INCLUDE_PATH}")
ENDFOREACH(CMAKE_INCLUDE_PATH)

FOREACH (example ${HDF_JAVA_EXAMPLES})
  FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
  "Main-Class: examples.datatypes.${example}
"
  )
  ADD_JAR (${example} ${PROJECT_BINARY_DIR}/Manifest.txt ${example}.java)
  GET_TARGET_PROPERTY(${example}_JAR_FILE ${example} JAR_FILE)
#  INSTALL_JAR (${example} ${HJAVA_INSTALL_DATA_DIR}/examples examples)
  GET_TARGET_PROPERTY(${example}_CLASSPATH ${example} CLASSDIR)
  ADD_DEPENDENCIES (${example} ${HDFJAVA_NCSA_HDF5_LIB_TARGET})
ENDFOREACH (example ${HDF_JAVA_EXAMPLES})

SET (CMAKE_JAVA_INCLUDE_PATH "${HDFJAVA_HDF5_JARS};${HDFJAVA_OBJECT_JARS}")

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (HDFJAVA_JAR ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${HDFJAVA_JAR}")
ENDFOREACH(HDFJAVA_JAR)

FOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})
  FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
  "Main-Class: examples.datatypes.${example}
"
  )
  ADD_JAR (${example} ${PROJECT_BINARY_DIR}/Manifest.txt ${example}.java)
  GET_TARGET_PROPERTY(${example}_JAR_FILE ${example} JAR_FILE)
#  INSTALL_JAR (${example} ${HJAVA_INSTALL_DATA_DIR}/examples examples)
  GET_TARGET_PROPERTY(${example}_CLASSPATH ${example} CLASSDIR)
  ADD_DEPENDENCIES (${example} ${HDFJAVA_NCSA_H5_LIB_TARGET})
ENDFOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})

MACRO (ADD_H5_TEST resultfile resultcode)
  ADD_TEST (
      NAME datatypes-${resultfile}
      COMMAND "${CMAKE_COMMAND}"
          -D "TEST_TESTER=${CMAKE_Java_RUNTIME}"
          -D "TEST_PROGRAM=examples.datatypes.${resultfile}"
          -D "TEST_ARGS:STRING=${ARGN}"
          -D "TEST_CLASSPATH:STRING=${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${${resultfile}_JAR_FILE}"
          -D "TEST_LIBRARY_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
          -D "TEST_FOLDER=${HDFJAVA_EXAMPLES_BINARY_DIR}"
          -D "TEST_OUTPUT=datatypes/${resultfile}.out"
          -D "TEST_EXPECT=${resultcode}"
          -D "TEST_REFERENCE=datatypes/${resultfile}.txt"
          -P "${HDFJAVA_RESOURCES_DIR}/runTest.cmake"
  )
  IF (NOT "${last_test}" STREQUAL "")
    SET_TESTS_PROPERTIES (datatypes-${resultfile} PROPERTIES DEPENDS ${last_test})
  ENDIF (NOT "${last_test}" STREQUAL "")
  SET (last_test "datatypes-${resultfile}")
ENDMACRO (ADD_H5_TEST file)

IF (BUILD_TESTING)

  FOREACH (example ${HDF_JAVA_EXAMPLES})
    ADD_TEST (
        NAME datatypes-${example}-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}.h5
            ${example}.out
            ${example}.out.err
    )
    IF (NOT "${last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (datatypes-${example}-clearall-objects PROPERTIES DEPENDS ${last_test})
    ENDIF (NOT "${last_test}" STREQUAL "")
    ADD_TEST (
        NAME datatypes-${example}-copy-objects
        COMMAND    ${CMAKE_COMMAND}
            -E copy_if_different 
            ${HDFJAVA_EXAMPLES_SOURCE_DIR}/testfiles/examples.datatypes.${example}.txt
            ${HDFJAVA_EXAMPLES_DATATYPES_BINARY_DIR}/${example}.txt  
    )
    SET_TESTS_PROPERTIES (datatypes-${example}-copy-objects PROPERTIES DEPENDS datatypes-${example}-clearall-objects)
    SET (last_test "datatypes-${example}-copy-objects")
    ADD_H5_TEST (${example} 0)
  ENDFOREACH (example ${HDF_JAVA_EXAMPLES})

  FOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})
    ADD_TEST (
        NAME datatypes-${example}-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}.h5
            ${example}.out
            ${example}.out.err
    )
    IF (NOT "${last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (datatypes-${example}-clearall-objects PROPERTIES DEPENDS ${last_test})
    ENDIF (NOT "${last_test}" STREQUAL "")
    ADD_TEST (
        NAME datatypes-${example}-copy-objects
        COMMAND    ${CMAKE_COMMAND}
            -E copy_if_different 
            ${HDFJAVA_EXAMPLES_SOURCE_DIR}/testfiles/examples.datatypes.${example}.txt
            ${HDFJAVA_EXAMPLES_DATATYPES_BINARY_DIR}/${example}.txt  
    )
    SET_TESTS_PROPERTIES (datatypes-${example}-copy-objects PROPERTIES DEPENDS datatypes-${example}-clearall-objects)
    SET (last_test "datatypes-${example}-copy-objects")
    ADD_H5_TEST (${example} 0)
  ENDFOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})

ENDIF (BUILD_TESTING)

=== examples/groups/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_EXAMPLES_GROUPS Java)

SET(CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES(
    ${JAVA_NCSA_HDF_HDF5_BINARY_DIR}
    ${HDFJAVA_LIB_DIR}
)

SET (HDF_JAVA_EXAMPLES
    H5Ex_G_Create
    H5Ex_G_Iterate
    H5Ex_G_Compact
    H5Ex_G_Corder
    H5Ex_G_Intermediate
    H5Ex_G_Phase
    H5Ex_G_Visit
)

SET (HDF_JAVA_OBJECT_EXAMPLES
    H5ObjectEx_G_Create
    H5ObjectEx_G_Iterate
    H5ObjectEx_G_Compact
    H5ObjectEx_G_Corder
    H5ObjectEx_G_Intermediate
    H5ObjectEx_G_Phase
    H5ObjectEx_G_Visit
)

IF (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ";")
ELSE (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ":")
ENDIF(WIN32 AND NOT CYGWIN)

SET (CMAKE_JAVA_INCLUDE_PATH ${HDFJAVA_HDF5_JARS})

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (CMAKE_INCLUDE_PATH ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_INCLUDE_PATH}")
ENDFOREACH(CMAKE_INCLUDE_PATH)

FOREACH (example ${HDF_JAVA_EXAMPLES})
  FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
  "Main-Class: examples.groups.${example}
"
  )
  ADD_JAR (${example} ${PROJECT_BINARY_DIR}/Manifest.txt ${example}.java)
  GET_TARGET_PROPERTY(${example}_JAR_FILE ${example} JAR_FILE)
#  INSTALL_JAR (${example} ${HJAVA_INSTALL_DATA_DIR}/examples examples)
  GET_TARGET_PROPERTY(${example}_CLASSPATH ${example} CLASSDIR)
  ADD_DEPENDENCIES (${example} ${HDFJAVA_NCSA_HDF5_LIB_TARGET})
ENDFOREACH (example ${HDF_JAVA_EXAMPLES})

SET (CMAKE_JAVA_INCLUDE_PATH "${HDFJAVA_HDF5_JARS};${HDFJAVA_OBJECT_JARS}")

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (HDFJAVA_JAR ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${HDFJAVA_JAR}")
ENDFOREACH(HDFJAVA_JAR)

FOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})
  FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
  "Main-Class: examples.groups.${example}
"
  )
  ADD_JAR (${example} ${PROJECT_BINARY_DIR}/Manifest.txt ${example}.java)
  GET_TARGET_PROPERTY(${example}_JAR_FILE ${example} JAR_FILE)
#  INSTALL_JAR (${example} ${HJAVA_INSTALL_DATA_DIR}/examples examples)
  GET_TARGET_PROPERTY(${example}_CLASSPATH ${example} CLASSDIR)
  ADD_DEPENDENCIES (${example} ${HDFJAVA_NCSA_H5_LIB_TARGET})
ENDFOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})

SET (HDF_JAVA_TEST_FILES
    h5ex_g_iterate.h5
    h5ex_g_visit.h5
)

FOREACH (h5_file ${HDF_JAVA_TEST_FILES})
  SET (dest "${PROJECT_BINARY_DIR}/${h5_file}")
  #MESSAGE (STATUS " Copying ${h5_file}")
  ADD_CUSTOM_COMMAND (
      TARGET     H5Ex_G_Visit
      POST_BUILD
      COMMAND    ${CMAKE_COMMAND}
      ARGS       -E copy_if_different ${PROJECT_SOURCE_DIR}/${h5_file} ${dest}
  )
ENDFOREACH (h5_file ${HDF_JAVA_TEST_FILES})

MACRO (ADD_H5_TEST resultfile resultcode)
  ADD_TEST (
      NAME groups-${resultfile}
      COMMAND "${CMAKE_COMMAND}"
          -D "TEST_TESTER=${CMAKE_Java_RUNTIME}"
          -D "TEST_PROGRAM=examples.groups.${resultfile}"
          -D "TEST_ARGS:STRING=${ARGN}"
          -D "TEST_CLASSPATH:STRING=${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${${resultfile}_JAR_FILE}"
          -D "TEST_LIBRARY_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
          -D "TEST_FOLDER=${HDFJAVA_EXAMPLES_BINARY_DIR}"
          -D "TEST_OUTPUT=groups/${resultfile}.out"
          -D "TEST_EXPECT=${resultcode}"
          -D "TEST_REFERENCE=groups/${resultfile}.txt"
          -P "${HDFJAVA_RESOURCES_DIR}/runTest.cmake"
  )
  IF (NOT "${last_test}" STREQUAL "")
    SET_TESTS_PROPERTIES (groups-${resultfile} PROPERTIES DEPENDS ${last_test})
  ENDIF (NOT "${last_test}" STREQUAL "")
  SET (last_test "groups-${resultfile}")
ENDMACRO (ADD_H5_TEST file)

IF (BUILD_TESTING)

  FOREACH (example ${HDF_JAVA_EXAMPLES})
    ADD_TEST (
        NAME groups-${example}-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${example}.out
            ${example}.out.err
    )
    IF (NOT "${last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (groups-${example}-clearall-objects PROPERTIES DEPENDS ${last_test})
    ENDIF (NOT "${last_test}" STREQUAL "")
    SET (last_test "groups-${example}-clearall-objects")
    IF (NOT ${example} STREQUAL "H5Ex_G_Iterate" AND NOT ${example} STREQUAL "H5Ex_G_Visit")
      IF (${example} STREQUAL "H5Ex_G_Compact")
        ADD_TEST (
            NAME groups-${example}-clearall-h5s
            COMMAND    ${CMAKE_COMMAND}
                -E remove
                ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}1.h5
                ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}2.h5
        )
      ELSE (${example} STREQUAL "H5Ex_G_Compact")
        ADD_TEST (
            NAME groups-${example}-clearall-h5s
            COMMAND    ${CMAKE_COMMAND}
                -E remove
                ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}.h5
        )
      ENDIF (${example} STREQUAL "H5Ex_G_Compact")
      IF (NOT "${last_test}" STREQUAL "")
        SET_TESTS_PROPERTIES (groups-${example}-clearall-h5s PROPERTIES DEPENDS ${last_test})
      ENDIF (NOT "${last_test}" STREQUAL "")
      SET (last_test "groups-${example}-clearall-h5s")
    ENDIF (NOT ${example} STREQUAL "H5Ex_G_Iterate" AND NOT ${example} STREQUAL "H5Ex_G_Visit")
    ADD_TEST (
        NAME groups-${example}-copy-objects
        COMMAND    ${CMAKE_COMMAND}
            -E copy_if_different 
            ${HDFJAVA_EXAMPLES_SOURCE_DIR}/testfiles/examples.groups.${example}.txt
            ${HDFJAVA_EXAMPLES_GROUPS_BINARY_DIR}/${example}.txt  
    )
    IF (NOT "${last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (groups-${example}-copy-objects PROPERTIES DEPENDS ${last_test})
    ENDIF (NOT "${last_test}" STREQUAL "")
    SET (last_test "groups-${example}-copy-objects")
    ADD_H5_TEST (${example} 0)
  ENDFOREACH (example ${HDF_JAVA_EXAMPLES})

  FOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})
    ADD_TEST (
        NAME groups-${example}-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${example}.out
            ${example}.out.err
    )
    IF (NOT "${last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (groups-${example}-clearall-objects PROPERTIES DEPENDS ${last_test})
    ENDIF (NOT "${last_test}" STREQUAL "")
    SET (last_test "groups-${example}-clearall-objects")
    IF (NOT ${example} STREQUAL "H5ObjectEx_G_Iterate" AND NOT ${example} STREQUAL "H5ObjectEx_G_Visit")
      IF (${example} STREQUAL "H5ObjectEx_G_Compact")
        ADD_TEST (
            NAME groups-${example}-clearall-h5s
            COMMAND    ${CMAKE_COMMAND}
                -E remove
                ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}1.h5
                ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}2.h5
        )
      ELSE (${example} STREQUAL "H5ObjectEx_G_Compact")
        ADD_TEST (
            NAME groups-${example}-clearall-h5s
            COMMAND    ${CMAKE_COMMAND}
                -E remove
                ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}.h5
        )
      ENDIF (${example} STREQUAL "H5ObjectEx_G_Compact")
      IF (NOT "${last_test}" STREQUAL "")
        SET_TESTS_PROPERTIES (groups-${example}-clearall-h5s PROPERTIES DEPENDS ${last_test})
      ENDIF (NOT "${last_test}" STREQUAL "")
      SET (last_test "groups-${example}-clearall-h5s")
    ENDIF (NOT ${example} STREQUAL "H5ObjectEx_G_Iterate" AND NOT ${example} STREQUAL "H5ObjectEx_G_Visit")
    ADD_TEST (
        NAME groups-${example}-copy-objects
        COMMAND    ${CMAKE_COMMAND}
            -E copy_if_different 
            ${HDFJAVA_EXAMPLES_SOURCE_DIR}/testfiles/examples.groups.${example}.txt
            ${HDFJAVA_EXAMPLES_GROUPS_BINARY_DIR}/${example}.txt  
    )
    IF (NOT "${last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (groups-${example}-copy-objects PROPERTIES DEPENDS ${last_test})
    ENDIF (NOT "${last_test}" STREQUAL "")
    SET (last_test "groups-${example}-copy-objects")
    ADD_H5_TEST (${example} 0)
  ENDFOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})

ENDIF (BUILD_TESTING)

=== examples/intro/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_EXAMPLES_INTRO Java)

SET(CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES(
    ${JAVA_NCSA_HDF_HDF5_BINARY_DIR}
    ${HDFJAVA_LIB_DIR}
)

SET (HDF_JAVA_EXAMPLES
    H5_CreateAttribute
    H5_CreateDataset
    H5_CreateFile
    H5_CreateGroup
    H5_CreateGroupAbsoluteRelative
    H5_CreateGroupDataset
    H5_ReadWrite
)

SET (HDF_JAVA_OBJECT_EXAMPLES
    H5Object_CreateAttribute
    H5Object_CreateDataset
    H5Object_CreateFile
    H5Object_CreateGroup
    H5Object_CreateGroupAbsoluteRelative
    H5Object_CreateGroupDataset
    H5Object_ReadWrite
)

IF (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ";")
ELSE (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ":")
ENDIF(WIN32 AND NOT CYGWIN)

SET (CMAKE_JAVA_INCLUDE_PATH ${HDFJAVA_HDF5_JARS})

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (CMAKE_INCLUDE_PATH ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_INCLUDE_PATH}")
ENDFOREACH(CMAKE_INCLUDE_PATH)

FOREACH (example ${HDF_JAVA_EXAMPLES})
  FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
  "Main-Class: examples.intro.${example}
"
  )
  ADD_JAR (${example} ${PROJECT_BINARY_DIR}/Manifest.txt ${example}.java)
  GET_TARGET_PROPERTY(${example}_JAR_FILE ${example} JAR_FILE)
#  INSTALL_JAR (${example} ${HJAVA_INSTALL_DATA_DIR}/examples examples)
  GET_TARGET_PROPERTY(${example}_CLASSPATH ${example} CLASSDIR)
  ADD_DEPENDENCIES (${example} ${HDFJAVA_NCSA_HDF5_LIB_TARGET})
ENDFOREACH (example ${HDF_JAVA_EXAMPLES})

SET (CMAKE_JAVA_INCLUDE_PATH "${HDFJAVA_HDF5_JARS};${HDFJAVA_OBJECT_JARS}")

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (HDFJAVA_JAR ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${HDFJAVA_JAR}")
ENDFOREACH(HDFJAVA_JAR)

FOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})
  FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
  "Main-Class: examples.intro.${example}
"
  )
  ADD_JAR (${example} ${PROJECT_BINARY_DIR}/Manifest.txt ${example}.java)
  GET_TARGET_PROPERTY(${example}_JAR_FILE ${example} JAR_FILE)
#  INSTALL_JAR (${example} ${HJAVA_INSTALL_DATA_DIR}/examples examples)
  GET_TARGET_PROPERTY(${example}_CLASSPATH ${example} CLASSDIR)
  ADD_DEPENDENCIES (${example} ${HDFJAVA_NCSA_H5_LIB_TARGET})
ENDFOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})

MACRO (ADD_H5_TEST resultfile resultcode)
  ADD_TEST (
      NAME intro-${resultfile}
      COMMAND "${CMAKE_COMMAND}"
          -D "TEST_TESTER=${CMAKE_Java_RUNTIME}"
          -D "TEST_PROGRAM=examples.intro.${resultfile}"
          -D "TEST_ARGS:STRING=${ARGN}"
          -D "TEST_CLASSPATH:STRING=${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${${resultfile}_JAR_FILE}"
          -D "TEST_LIBRARY_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
          -D "TEST_FOLDER=${HDFJAVA_EXAMPLES_BINARY_DIR}"
          -D "TEST_OUTPUT=intro/${resultfile}.out"
          -D "TEST_EXPECT=${resultcode}"
          -D "TEST_REFERENCE=intro/${resultfile}.txt"
          -P "${HDFJAVA_RESOURCES_DIR}/runTest.cmake"
  )
  IF (NOT "${last_test}" STREQUAL "")
    SET_TESTS_PROPERTIES (intro-${resultfile} PROPERTIES DEPENDS ${last_test})
  ENDIF (NOT "${last_test}" STREQUAL "")
  SET (last_test "intro-${resultfile}")
ENDMACRO (ADD_H5_TEST file)

IF (BUILD_TESTING)

  FOREACH (example ${HDF_JAVA_EXAMPLES})
    ADD_TEST (
        NAME intro-${example}-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}.h5
            ${example}.out
            ${example}.out.err
    )
    IF (NOT "${last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (intro-${example}-clearall-objects PROPERTIES DEPENDS ${last_test})
    ENDIF (NOT "${last_test}" STREQUAL "")
    ADD_TEST (
        NAME intro-${example}-copy-objects
        COMMAND    ${CMAKE_COMMAND}
            -E copy_if_different 
            ${HDFJAVA_EXAMPLES_SOURCE_DIR}/testfiles/examples.intro.${example}.txt
            ${HDFJAVA_EXAMPLES_INTRO_BINARY_DIR}/${example}.txt  
    )
    SET_TESTS_PROPERTIES (intro-${example}-copy-objects PROPERTIES DEPENDS intro-${example}-clearall-objects)
    SET (last_test "intro-${example}-copy-objects")
    ADD_H5_TEST (${example} 0)
  ENDFOREACH (example ${HDF_JAVA_EXAMPLES})

  FOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})
    ADD_TEST (
        NAME intro-${example}-clearall-objects
        COMMAND    ${CMAKE_COMMAND}
            -E remove
            ${HDFJAVA_EXAMPLES_BINARY_DIR}/${example}.h5
            ${example}.out
            ${example}.out.err
    )
    IF (NOT "${last_test}" STREQUAL "")
      SET_TESTS_PROPERTIES (intro-${example}-clearall-objects PROPERTIES DEPENDS ${last_test})
    ENDIF (NOT "${last_test}" STREQUAL "")
    ADD_TEST (
        NAME intro-${example}-copy-objects
        COMMAND    ${CMAKE_COMMAND}
            -E copy_if_different 
            ${HDFJAVA_EXAMPLES_SOURCE_DIR}/testfiles/examples.intro.${example}.txt
            ${HDFJAVA_EXAMPLES_INTRO_BINARY_DIR}/${example}.txt  
    )
    SET_TESTS_PROPERTIES (intro-${example}-copy-objects PROPERTIES DEPENDS intro-${example}-clearall-objects)
    SET (last_test "intro-${example}-copy-objects")
    ADD_H5_TEST (${example} 0)
  ENDFOREACH (example ${HDF_JAVA_OBJECT_EXAMPLES})

ENDIF (BUILD_TESTING)

=== native/hdf5lib/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_JNI_HDF5LIB C)

SET (HDFJAVA_JNI_HDF5_CSRCS
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/exceptionImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5aImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5Constants.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5dImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5eImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5fImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5gImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5iImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5Imp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5lImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5oImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5pImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5rImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5sImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5tImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5util.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5zImp.c
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/nativeData.c
)

SET (HDFJAVA_JNI_HDF5_CHDRS
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5dImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5eImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5fImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5gImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5jni.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5lImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5oImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5sImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5tImp.h
    ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR}/h5util.h
)

INCLUDE_DIRECTORIES( ${HDFJAVA_JNI_HDF5LIB_SOURCE_DIR} )

########### JNI libraries always must be built shared  ###############
ADD_LIBRARY (${HDFJAVA_JNI_HDF5_LIB_TARGET} SHARED ${HDFJAVA_JNI_HDF5_CSRCS} ${HDFJAVA_JNI_HDF5_CHDRS})
TARGET_LINK_LIBRARIES (${HDFJAVA_JNI_HDF5_LIB_TARGET} ${HDF5_LINK_LIBS})
SET_GLOBAL_VARIABLE (HDFJAVA_LIBRARIES_TO_EXPORT "${HDFJAVA_LIBRARIES_TO_EXPORT};${HDFJAVA_JNI_HDF5_LIB_TARGET}")
HDFJAVA_SET_LIB_OPTIONS (${HDFJAVA_JNI_HDF5_LIB_TARGET} ${HDFJAVA_JNI_HDF5_LIB_NAME} SHARED)
IF (WIN32 AND NOT CYGWIN)
  GET_FILENAME_COMPONENT(HDFJAVA_JNI_HDF5_DLL_NAME ${HDFJAVA_JNI_HDF5_LIB_TARGET} NAME_WE)
  # MESSAGE (STATUS "HDFJAVA_JNI_HDF5_DLL_NAME: ${HDFJAVA_JNI_HDF5_DLL_NAME}")
  IF (BUILD_TESTING)
    ADD_CUSTOM_TARGET (HDFJAVA_JNI_HDF5-Test-Copy ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${HDFJAVA_JNI_HDF5_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${HDFJAVA_JNI_HDF5_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}
        COMMENT "Copying ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${HDFJAVA_JNI_HDF5_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX} to ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/"
    )
    ADD_DEPENDENCIES (HDFJAVA_JNI_HDF5-Test-Copy ${HDFJAVA_JNI_HDF5_LIB_TARGET})
  ENDIF (BUILD_TESTING)
ENDIF (WIN32 AND NOT CYGWIN)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
IF (HDFJAVA_EXPORTED_TARGETS)
  INSTALL (
      TARGETS 
          ${HDFJAVA_JNI_HDF5_LIB_TARGET}
      EXPORT
          ${HDFJAVA_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries 
      ARCHIVE DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries
  )
ENDIF (HDFJAVA_EXPORTED_TARGETS)

=== native/hdflib/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_JNI_HDFLIB C)

SET (HDFJAVA_JNI_HDF_CSRCS
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfanImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfanImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfcompImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfpalImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfsdImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfdfuImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfexceptionImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfgrImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfheImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfhxImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfnativeImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfr24Imp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfr8Imp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfsdsImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfstructsutil.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvdataImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvfImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvgroupImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvhImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvqImp.c
    ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR}/hdfvsqImp.c
)

INCLUDE_DIRECTORIES( ${HDFJAVA_JNI_HDFLIB_SOURCE_DIR} )

########### JNI libraries always must be built shared  ###############
ADD_LIBRARY (${HDFJAVA_JNI_HDF_LIB_TARGET} SHARED ${HDFJAVA_JNI_HDF_CSRCS})
IF (WIN32 AND NOT CYGWIN)
  TARGET_LINK_LIBRARIES (${HDFJAVA_JNI_HDF_LIB_TARGET} ${HDF4_LINK_LIBS} "ws2_32.lib")
ELSE (WIN32 AND NOT CYGWIN)
  TARGET_LINK_LIBRARIES (${HDFJAVA_JNI_HDF_LIB_TARGET} ${HDF4_LINK_LIBS})
ENDIF (WIN32 AND NOT CYGWIN)
SET_GLOBAL_VARIABLE (HDFJAVA_LIBRARIES_TO_EXPORT "${HDFJAVA_LIBRARIES_TO_EXPORT};${HDFJAVA_JNI_HDF_LIB_TARGET}")
HDFJAVA_SET_LIB_OPTIONS (${HDFJAVA_JNI_HDF_LIB_TARGET} ${HDFJAVA_JNI_HDF_LIB_NAME} SHARED)
IF (WIN32 AND NOT CYGWIN)
  GET_FILENAME_COMPONENT(HDFJAVA_JNI_HDF_DLL_NAME ${HDFJAVA_JNI_HDF_LIB_TARGET} NAME_WE)
  # MESSAGE (STATUS "HDFJAVA_JNI_HDF_DLL_NAME: ${HDFJAVA_JNI_HDF_DLL_NAME}")
  IF (BUILD_TESTING)
    ADD_CUSTOM_TARGET (HDFJAVA_JNI_HDF-Test-Copy ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${HDFJAVA_JNI_HDF_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX} ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${HDFJAVA_JNI_HDF_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX}
        COMMENT "Copying ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${HDFJAVA_JNI_HDF_DLL_NAME}${CMAKE_SHARED_LIBRARY_SUFFIX} to ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/"
    )
    ADD_DEPENDENCIES (HDFJAVA_JNI_HDF-Test-Copy ${HDFJAVA_JNI_HDF_LIB_TARGET})
  ENDIF (BUILD_TESTING)
ENDIF (WIN32 AND NOT CYGWIN)

#-----------------------------------------------------------------------------
# Add Target(s) to CMake Install for import into other projects
#-----------------------------------------------------------------------------
IF (HDFJAVA_EXPORTED_TARGETS)
  INSTALL (
      TARGETS 
          ${HDFJAVA_JNI_HDF_LIB_TARGET}
      EXPORT
          ${HDFJAVA_EXPORTED_TARGETS}
      LIBRARY DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries 
      ARCHIVE DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries
      RUNTIME DESTINATION ${HJAVA_INSTALL_LIB_DIR} COMPONENT libraries
  )
ENDIF (HDFJAVA_EXPORTED_TARGETS)

=== ncsa/hdf/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_NCSA_HDF)

ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_SOURCE_DIR}/hdflib      hdflib)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_SOURCE_DIR}/hdf5lib     hdf5lib)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_SOURCE_DIR}/object      object)
ADD_SUBDIRECTORY(${HDFJAVA_NCSA_HDF_SOURCE_DIR}/view        view)

=== test/hdf5lib/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_TEST_HDF5LIB Java)

SET(CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES(
    ${JAVA_NCSA_HDF_HDF4_BINARY_DIR}
    ${JAVA_NCSA_HDF_HDF5_BINARY_DIR}
    ${JAVA_NCSA_HDF_OBJECT_BINARY_DIR}
    ${HDFJAVA_LIB_DIR}
)

SET (HDFJAVA_TEST_HDF5LIB_SRCS
    TestH5.java
    TestH5E.java
    TestH5Edefault.java
    TestH5Eregister.java
    TestH5Fparams.java
    TestH5Fbasic.java
    TestH5F.java
    TestH5Gbasic.java
    TestH5G.java
    TestH5Giterate.java
    TestH5Sbasic.java
    TestH5S.java
    TestH5Tparams.java
    TestH5Tbasic.java
    TestH5T.java
    TestH5Dparams.java
    TestH5D.java
    TestH5Dplist.java
    TestH5Lparams.java
    TestH5Lbasic.java
    TestH5Lcreate.java
    TestH5R.java
    TestH5P.java
    TestH5PData.java
    TestH5Pfapl.java
    TestH5A.java
    TestH5Oparams.java
    TestH5Obasic.java
    TestH5Ocreate.java
    TestH5Ocopy.java
    TestH5Z.java
    TestAll.java
)

FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
"Main-Class: test.hdf5lib.TestAll
"
)

SET (CMAKE_JAVA_INCLUDE_PATH "${HDFJAVA_LIB_DIR}/junit.jar;${HDFJAVA_HDF5_JARS}")

ADD_JAR (${HDFJAVA_TEST_HDF5_LIB_TARGET} ${PROJECT_BINARY_DIR}/Manifest.txt ${HDFJAVA_TEST_HDF5LIB_SRCS})

GET_TARGET_PROPERTY(${HDFJAVA_TEST_HDF5_LIB_TARGET}_JAR_FILE ${HDFJAVA_TEST_HDF5_LIB_TARGET} JAR_FILE)
#INSTALL_JAR (${HDFJAVA_TEST_HDF5_LIB_TARGET} ${HJAVA_INSTALL_DATA_DIR}/tests tests)
#GET_TARGET_PROPERTY(${HDFJAVA_TEST_HDF5_LIB_TARGET}_CLASSPATH ${HDFJAVA_TEST_HDF5_LIB_TARGET} CLASSDIR)

ADD_DEPENDENCIES (${HDFJAVA_TEST_HDF5_LIB_TARGET} ${HDFJAVA_NCSA_HDF5_LIB_TARGET})

SET (HDF_JAVA_TEST_FILES
      h5ex_g_iterate.hdf
      JUnit-interface.txt
)

FOREACH (h5_file ${HDF_JAVA_TEST_FILES})
  SET (dest "${PROJECT_BINARY_DIR}/${h5_file}")
  #MESSAGE (STATUS " Copying ${h5_file}")
  ADD_CUSTOM_COMMAND (
      TARGET     ${HDFJAVA_TEST_HDF5_LIB_TARGET}
      POST_BUILD
      COMMAND    ${CMAKE_COMMAND}
      ARGS       -E copy_if_different ${PROJECT_SOURCE_DIR}/${h5_file} ${dest}
  )
ENDFOREACH (h5_file ${HDF_JAVA_TEST_FILES})

IF (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ";")
ELSE (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ":")
ENDIF(WIN32 AND NOT CYGWIN)

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (CMAKE_INCLUDE_PATH ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_INCLUDE_PATH}")
ENDFOREACH(CMAKE_INCLUDE_PATH)
SET (CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${${HDFJAVA_TEST_HDF5_LIB_TARGET}_JAR_FILE}")
SET (testfilter "OK (598 tests)")

ADD_TEST (
    NAME JUnit-interface
    COMMAND "${CMAKE_COMMAND}"
        -D "TEST_TESTER=${CMAKE_Java_RUNTIME}"
        -D "TEST_CLASSPATH:STRING=${CMAKE_JAVA_CLASSPATH}"
        -D "TEST_ARGS:STRING=-ea;org.junit.runner.JUnitCore"
        -D "TEST_PROGRAM=test.hdf5lib.TestAll"
        -D "TEST_LIBRARY_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
        -D "TEST_FOLDER=${HDFJAVA_BINARY_DIR}"
        -D "TEST_OUTPUT=${HDFJAVA_TEST_HDF5LIB_BINARY_DIR}/JUnit-interface.out"
        -D "TEST_EXPECT=0"
        -D "TEST_SKIP_COMPARE=TRUE"
        -D "TEST_FILTER:STRING=${testfilter}"
        -D "TEST_REFERENCE=${testfilter}"
        -P "${HDFJAVA_RESOURCES_DIR}/runTest.cmake"
)

=== test/object/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.6)
PROJECT (HDFJAVA_TEST_OBJECT Java)

SET(CMAKE_VERBOSE_MAKEFILE 1)

INCLUDE_DIRECTORIES(
    ${JAVA_NCSA_HDF_HDF4_BINARY_DIR}
    ${JAVA_NCSA_HDF_HDF5_BINARY_DIR}
    ${JAVA_NCSA_HDF_OBJECT_BINARY_DIR}
    ${HDFJAVA_LIB_DIR}
)

SET (HDFJAVA_TEST_OBJECT_SRCS
    AllH5ObjectTests.java
    AttributeTest.java
    CompoundDSTest.java
    DatasetTest.java
    DatatypeTest.java
    DataFormatTest.java
    FileFormatTest.java
    GroupTest.java
    H5BugFixTest.java
    H5CompoundDSTest.java
    H5DatatypeTest.java
    H5FileTest.java
    H5GroupTest.java
    H5ScalarDSTest.java
    H5TestFile.java
    HObjectTest.java
    MetadataTest.java
    ScalarDSTest.java
)

FILE (WRITE ${PROJECT_BINARY_DIR}/Manifest.txt
"Main-Class: test.object.AllH5ObjectTests

"
)

SET (CMAKE_JAVA_INCLUDE_PATH "${HDFJAVA_LIB_DIR}/junit.jar;${HDFJAVA_OBJECT_JARS};${HDFJAVA_HDF5_JARS}")

ADD_JAR (${HDFJAVA_TEST_OBJECT_LIB_TARGET} ${PROJECT_BINARY_DIR}/Manifest.txt ${HDFJAVA_TEST_OBJECT_SRCS})

GET_TARGET_PROPERTY(${HDFJAVA_TEST_OBJECT_LIB_TARGET}_JAR_FILE ${HDFJAVA_TEST_OBJECT_LIB_TARGET} JAR_FILE)
#INSTALL_JAR (${HDFJAVA_TEST_OBJECT_LIB_TARGET} ${HJAVA_INSTALL_DATA_DIR}/tests tests)

ADD_DEPENDENCIES (${HDFJAVA_TEST_OBJECT_LIB_TARGET} ${HDFJAVA_NCSA_HDF5_LIB_TARGET} ${HDFJAVA_NCSA_H5_LIB_TARGET})

SET (HDF_JAVA_TEST_FILES
      h5ex_d_extern.data
      h5ex_d_extern.hdf5
      JUnit-object-interface.txt
)

FOREACH (h5_file ${HDF_JAVA_TEST_FILES})
  SET (dest "${PROJECT_BINARY_DIR}/${h5_file}")
  #MESSAGE (STATUS " Copying ${h5_file}")
  ADD_CUSTOM_COMMAND (
      TARGET     ${HDFJAVA_TEST_OBJECT_LIB_TARGET}
      POST_BUILD
      COMMAND    ${CMAKE_COMMAND}
      ARGS       -E copy_if_different ${PROJECT_SOURCE_DIR}/${h5_file} ${dest}
  )
ENDFOREACH (h5_file ${HDF_JAVA_TEST_FILES})

IF (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ";")
ELSE (WIN32 AND NOT CYGWIN)
  SET(CMAKE_JAVA_INCLUDE_FLAG_SEP ":")
ENDIF(WIN32 AND NOT CYGWIN)

SET (CMAKE_JAVA_CLASSPATH ".")
FOREACH (CMAKE_INCLUDE_PATH ${CMAKE_JAVA_INCLUDE_PATH})
  SET(CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${CMAKE_INCLUDE_PATH}")
ENDFOREACH(CMAKE_INCLUDE_PATH)
SET (CMAKE_JAVA_CLASSPATH "${CMAKE_JAVA_CLASSPATH}${CMAKE_JAVA_INCLUDE_FLAG_SEP}${${HDFJAVA_TEST_OBJECT_LIB_TARGET}_JAR_FILE}")
SET (testfilter "OK (153 tests)")

ADD_TEST (
    NAME JUnit-object-interface
    COMMAND "${CMAKE_COMMAND}"
        -D "TEST_TESTER=${CMAKE_Java_RUNTIME}"
        -D "TEST_CLASSPATH:STRING=${CMAKE_JAVA_CLASSPATH}"
        -D "TEST_ARGS:STRING="
        -D "TEST_PROGRAM=-ea;org.junit.runner.JUnitCore;test.object.AllH5ObjectTests"
        -D "TEST_LIBRARY_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}"
        -D "TEST_FOLDER=${HDFJAVA_BINARY_DIR}"
        -D "TEST_OUTPUT=${HDFJAVA_TEST_OBJECT_BINARY_DIR}/JUnit-object-interface.out"
        -D "TEST_EXPECT=0"
        -D "TEST_FILTER:STRING=${testfilter}"
        -D "TEST_REFERENCE=${testfilter}"
        -D "TEST_SKIP_COMPARE=TRUE"
        -P "${HDFJAVA_RESOURCES_DIR}/runTest.cmake"
)

=== debian/changelog ===
jhdf (2.9-1) unstable; urgency=low

  * Upload to unstable
  * Disable the shipping of all setting files (Closes: #713190)
  * Standards-Version updated to 3.9.4
  * Remove the -v option to autoreconf
  * Update of the .install path of libjhdf5

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 28 May 2013 18:32:17 +0200

jhdf (2.9-1~exp1) experimental; urgency=low

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 05 Dec 2012 11:45:18 +0100

jhdf (2.8.0-6~exp1) experimental; urgency=low

  [ James Page ]
  * Drop build dependencies on openjdk-{6|7}-jdk,
    version default-jdk (>= 1:1.6).
    (Closes: #683552)
  * d/patches/source1.5.diff: Also set -target 1.5 to ensure backwards
    compatible bytecode is created.

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 02 Aug 2012 10:00:13 +0200

=== debian/control ===
Source: jhdf
Section: libs
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 7), autotools-dev, cdbs, default-jdk (>= 1:1.6),
 libjpeg-dev, zlib1g-dev, libhdf4-dev, libhdf5-dev (>= 1.8.8),
 automake, autoconf, imagemagick
Standards-Version: 3.9.4
Homepage: http://www.hdfgroup.org/hdf-java-html/
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/jhdf/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/jhdf/

Package: libjhdf5-java
Section: java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libjhdf5-jni
Description: Java HDF5 Object Package
 HDF is a versatile data model that can represent very complex data objects
 and a wide variety of metadata. It is a completely portable file format
 with no limit on the number or size of data objects in the collection.
 .
 This Java package implements HDF5 data objects in an
 object-oriented form. It provides a common Java API for accessing HDF5 files.

Package: libjhdf5-jni
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Java HDF5 Object Package (Java JNI library)
 HDF is a versatile data model that can represent very complex data objects
 and a wide variety of metadata. It is a completely portable file format
 with no limit on the number or size of data objects in the collection.
 .
 This Java package implements HDF5 data objects in an 
 object-oriented form. It provides a common Java API for accessing HDF5 files.
 .
 This package includes the architecture specific Java Native Interface part
 for the Java bindings for HDF5.

Package: libjhdf-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends} 
Description: Java HDF Object Package - Documentation
 HDF is a versatile data model that can represent very complex data objects
 and a wide variety of metadata. It is a completely portable file format
 with no limit on the number or size of data objects in the collection.
 .
 This package includes the documentation for HDF/HDF5 packages.

Package: libjhdf4-java
Section: java
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libjhdf4-jni
Description: Java HDF4 Object Package
 HDF is a versatile data model that can represent very complex data objects
 and a wide variety of metadata. It is a completely portable file format
 with no limit on the number or size of data objects in the collection.
 .
 This Java package implements HDF4 data objects in an 
 object-oriented form. It provides a common Java API for accessing HDF4 files.
 .
 This package includes the architecture specific Java Native Interface part
 for the Java bindings for HDF4.

Package: libjhdf4-jni
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends} 
Description: Java HDF4 Object Package (Java JNI library)
 HDF is a versatile data model that can represent very complex data objects
 and a wide variety of metadata. It is a completely portable file format
 with no limit on the number or size of data objects in the collection.
 .
 This Java package implements HDF4 data objects in an 
 object-oriented form. It provides a common Java API for accessing HDF4 files.
 .
 This package includes the architecture specific Java Native Interface part
 for the Java bindings for HDF4.

Package: hdfview
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libjgraph-java, libjhdf5-java,
 libjhdf4-java, java-wrappers, default-jre
Suggests: www-browser
Description: Java HDF Object viewer
 HDF is a versatile data model that can represent very complex data objects
 and a wide variety of metadata. It is a completely portable file format
 with no limit on the number or size of data objects in the collection.
 .
 This package provides a HDF4/HDF5 viewer.

=== debian/rules ===
#!/usr/bin/make -f
# Copyright 2008 Sylvestre Ledru <sylvestre.ledru@inria.fr>

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/autotools.mk

debian/stamp-autotools-files:
	autoreconf -i
	touch debian/stamp-autotools-files


DEB_CONFIGURE_EXTRA_FLAGS := CC=gcc

DEB_CONFIGURE_NORMAL_ARGS += --with-jdk=/usr/lib/jvm/default-java/include/,/usr/lib/jvm/default-java/lib/ --with-classpath=/usr/lib/jvm/default-java/lib/ --with-javabin=/usr/lib/jvm/default-java/bin/  --with-libz=yes,/usr/lib  --with-libjpeg=yes,/usr/lib/   --with-hdf5=/usr/include,/usr/lib --with-hdf4=/usr/include/hdf/,/usr/lib/
DEB_CONFIGURE_PREFIX := $(CURDIR)/debian/tmp/

=== debian/watch ===
version=3
http://www.hdfgroup.org/ftp/HDF5/hdf-java/src/ \
hdf-java-([\d\.]+)-src.tar \
debian debian/orig-tar.sh
